PortView (JGraph v5.12.4.2 API Specification)
Keywords: org.jgraph.graph.PortView class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JGraph v5.12.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jgraph.graph
Class PortView

    java.lang.Object
      org.jgraph.graph.AbstractCellView
          org.jgraph.graph.PortView

All Implemented Interfaces:
  CellView, Serializable

public class PortView
extends AbstractCellView

The default implementation of a port view.

See Also:
  Serialized Form

Field Summary
`static boolean` | `allowPortMagic` Controls if port magic should be allowed.
`protected CellView` | `lastParent` Cache of the last valid parent.
`static PortRenderer` | `renderer` Renderer for the class.
`static int` | `SIZE` Default size for all ports is 6.

Fields inherited from class org.jgraph.graph.AbstractCellView
`allAttributes, attributes, cell, cellEditor, childViews, groupBounds, parent`

Constructor Summary
`PortView()` Constructs an empty portview.
`PortView(Object cell)` Constructs a view that holds a reference to the specified cell, anchor and parent vertex.

Method Summary
`Rectangle2D` | `getBounds()` Returns the bounds for the port view.
`CellHandle` | `getHandle(GraphContext context)` Returns `null`.
`Point2D` | `getLocation()` Shortcut method to getLocation(null, null)
`Point2D` | `getLocation(EdgeView edge)` For backwards compatibility.
`Point2D` | `getLocation(EdgeView edge, Point2D nearest)` Returns the point that the port represents with respect to `edge` and `point`, which is the nearest point to this port view on the edge.
`CellView` | `getParentView()` This method ensures a non-null value.
`int` | `getPortSize()`
`CellViewRenderer` | `getRenderer()` Returns a renderer for the class.
`void` | `setPortSize(int size)`
`protected boolean` | `shouldInvokePortMagic(EdgeView edge)` Subclassers can override this to decide whether or not "port magic" should appear on a given edge.

Methods inherited from class org.jgraph.graph.AbstractCellView
`changeAttributes, childUpdated, createAttributeMap, getAllAttributes, getAttributes, getBounds, getCell, getCellAttributes, getCenterPoint, getChildViews, getDescendantViews, getEditor, getPerimeterPoint, getRendererComponent, includeInGroupBounds, intersects, isLeaf, mergeAttributes, refresh, removeFromParent, scale, setAttributes, setBounds, setCell, translate, update, updateGroupBounds`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### SIZE

    public static transient int SIZE

  Default size for all ports is 6.

### renderer

    public static transient PortRenderer renderer

  Renderer for the class.

### allowPortMagic

    public static boolean allowPortMagic

  Controls if port magic should be allowed. Default is true. This is an easy switch to disable port magic for all instances of graphs.

### lastParent

    protected transient CellView lastParent

  Cache of the last valid parent. //FIX: Better solution?

Constructor Detail

### PortView

    public PortView()

  Constructs an empty portview.

### PortView

    public PortView(Object cell)

  Constructs a view that holds a reference to the specified cell, anchor and parent vertex.

Parameters:
  `cell` - reference to the cell in the model

Method Detail

### getParentView

    public CellView getParentView()

  This method ensures a non-null value. If the super method returns null then the last valid parent is returned. Note: If a vertex is removed, all ports will be replaced in connected edges. The ports are replaced by the center point of the last valid vertex view.

  Specified by:
    `getParentView` in interface `CellView`
  Overrides:
    `getParentView` in class `AbstractCellView`
  Returns:
    the parent view for this view

### getBounds

    public Rectangle2D getBounds()

  Returns the bounds for the port view.

  Specified by:
    `getBounds` in interface `CellView`
  Overrides:
    `getBounds` in class `AbstractCellView`

### getRenderer

    public CellViewRenderer getRenderer()

  Returns a renderer for the class.

  Specified by:
    `getRenderer` in class `AbstractCellView`
  Returns:
    the renderer instance for this view

### getHandle

    public CellHandle getHandle(GraphContext context)

  Returns `null`.

  Specified by:
    `getHandle` in interface `CellView`
  Specified by:
    `getHandle` in class `AbstractCellView`
  Parameters:
    `context` - the context of this cell view (cells indirectly affected by it)
  Returns:
    the cell handle for this view

### getLocation

    public Point2D getLocation()

  Shortcut method to getLocation(null, null)

### getLocation

    public Point2D getLocation(EdgeView edge)

  For backwards compatibility.

### getLocation

    public Point2D getLocation(EdgeView edge,
                               Point2D nearest)

  Returns the point that the port represents with respect to `edge` and `point`, which is the nearest point to this port view on the edge. `edge` and `point` may be `null`.

### shouldInvokePortMagic

    protected boolean shouldInvokePortMagic(EdgeView edge)

  Subclassers can override this to decide whether or not "port magic" should appear on a given edge. (Port magic means the port tries to make the edge horizontal or vertical if the closest control point lies within the bounds of the parent vertex.)

### getPortSize

    public int getPortSize()

  Returns:
    the port size

### setPortSize

    public void setPortSize(int size)

  Parameters:
    `size` - the port size to set

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JGraph v5.12.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) 2001-2008 Gaudenz Alder. All rights reserved.